var historie = new Array() // pole s spoupností procházených pojmů - historie
var max_historie = 10;  // limit historie 
var historie_actual = -1; // ukazatel aktuální pojmu při procházení hstorie
var terminy = new Array(); // pole s pojmy
var lineDelimiter = "$" // oddělovač řádků
var initialized = false; // promenna urcujici, zda jiz byl seznam pojmu nacten

// konstruktor objektu pojmu
function Pojem() {
  this.title = ""; // název 
  this.subtitle = "" // podtitul
}

// nacteni seznamu pojmu do iframu
function loadTermsList() {
  document.getElementById("termsListLoader").src = "terms/terms.txt";
}

// odstraneni tagu <pre></pre> ze vstupniho textu
function removeTagPre(text) {
  text=text.substr(5);
    if (text.toLowerCase().substr(text.length-6)=="</pre>") {
      text=text.substring(0,text.length-6);
    }
  return text;
}

//inicializace aplikace
function init() {
  var termsList = document.getElementById("termsListLoader").contentWindow.document.body.innerHTML;
    if (termsList!="" && !initialized) {
      actualTerm = 0;
    
      termsList = removeTagPre(termsList);
        if (navigator.appName=="Netscape") {
          var termsArray = termsList.split(String.fromCharCode(10));
        } else {
          var termsArray = termsList.split(String.fromCharCode(13,10));
        }
      
      for (var i = 0; i < termsArray.length; i++) {// načtení pojmů
        if (termsArray[i]!="") {
          var termin = new Pojem()
          termin.title = termsArray[i].split("#")[0];
          termin.subtitle = termsArray[i].split("#")[1];
          terminy.push(termin);
        }
      }
     // terminy.sort(sortByTitle);
      
      showTerm(0);
      showList("");
      
      initialized = true;
    }
}


// uložení pojmu do hisorie
function putToHistory(index) {
  if (historie.length == max_historie) {
    historie.shift()
  }
  historie.push(index);
  setActualHistory(historie.length-1)
 
}

// nastavení aktuálního pojmu v historii 
function setActualHistory(index) {
  historie_actual = index;
  var history_prev = document.getElementById("history_prev");
  var history_next = document.getElementById("history_next");
  if (index == 0) { // zablokovani predchoziho talcitka
    history_prev.src = "design/l_inactive.png"
  }
  if (index > 0) {
    history_prev.src = "design/l_active.png"
  }
  if (index == historie.length-1) { //zabokovani dalsiho tlacitka
    history_next.src = "design/r_inactive.png";
  }
  if (index < historie.length-1 && historie.length > 1) { //odblokovani dalsiho tlacitka
    history_next.src = "design/r_active.png";
  }
 
} 

// přechod na předcházející pojem v historii 
function goPrev() {
  if (historie_actual > 0) {
    showTerm(historie[--historie_actual],false)
    setActualHistory(historie_actual)
  }
} 

// přechod na následující pojem v historii 
function goNext() {
  if (historie_actual < historie.length-1 ) {
    showTerm(historie[++historie_actual], false)
    setActualHistory(historie_actual)
  }
}

// funkce vraci nazev souboru obsahujici dany pojem
function getFileNameFromTitle(title) {
  var diacritics = ['á'   ,'à'   ,'ă'   ,'ä'   ,'â'   ,'ą'   ,'å'   ,'ā'   ,'æ'   ,'ã'   ,'č'   ,'ć'   ,'ç'   ,'ď'   ,'đ'   ,'é'   ,'ě'   ,'è'   ,'ë'   ,'ę'   ,'ê'   ,'í'   ,'ì'   ,'ï'   ,'î'   ,'ī'   ,'ľ'   ,'ł'   ,'ň'   ,'ń'   ,'ñ'   ,'ó'   ,'ò'   ,'ŏ'   ,'ö'   ,'ő'   ,'ô'   ,'ō'   ,'õ'   ,'ø'   ,'ř'   ,'ŕ'   ,'š'   ,'ś'   ,'ş'   ,'ť'   ,'ţ'   ,'ú'   ,'ů'   ,'ù'   ,'ü'   ,'ű'   ,'ŭ'   ,'ǔ'   ,'ū'   ,'ý'   ,'ŷ'   ,'ž'   ,' ',' ','–'    ,'.'   ,':'   ,','   ,'/'   ,'&'   ,'*'   ,'…'    ,'('   ,')'   ,'['   ,']'   ,'„'    ,'“'    ,'”'    ,'’'    ,'‘'    ,'‚'    ];
  var      chars = ['a225','a224','a259','a228','a226','a261','a229','a257','a230','a227','c269','c263','c231','d271','d273','e233','e283','e232','e235','e281','e234','i237','i236','i239','i238','i299','l318','l322','n328','n324','n241','o243','o242','o335','o246','o337','o244','o333','o245','o248','r345','r341','s353','s347','s351','t357','t355','u250','u367','u249','u252','u369','u365','u468','u363','y253','y375','z382','_','_','-8211','-046','-058','-044','-047','-038','-042','-8230','-040','-041','-091','-093','-8222','-8220','-8221','-8217','-8216','-8218'];
  title=title.toLowerCase();
    for (var i=0; i<diacritics.length; i++) {
      title=title.split(diacritics[i]).join(chars[i]); // vyreseno takto, protoze u replaceAll nefunguji tyto znaky: *,(,),[
    }
  return title;
}

// po nacteni obsahu iframu zobrazi obsah pojmu
function showDescription() {
  var description = document.getElementById("termLoader").contentWindow.document.body.innerHTML;
  description = removeTagPre(description);
  description = description.replaceAll("&amp;","&");
  setHTML("termdescription", wikify(description));
  document.getElementById("termdescription").style.color = "#333";
}

// zobrazení index-tého pojmu toHistory - ukazatel, jestli se má uložit do historie (true/false)
function showTerm(index, toHistory) {
  if (toHistory) putToHistory(index)
  showNode("info")
  var pojem = terminy[index];
  var capital = "";
  
  setHTML("termdescription", "<p>pojem se načítá&hellip;</p>");
  document.getElementById("termdescription").style.color = "gray";
  
  var fileName = getFileNameFromTitle(pojem.title);
    if (pojem.title.charAt(0).toLowerCase() != pojem.title.charAt(0)) {
      capital= "_velke";
    }
  document.getElementById("termLoader").src = "terms/" + fileName.charAt(0) + "/" + fileName + capital + ".txt";
  
	setHTML("desc_title", pojem.title);
	setHTML("desc_subtitle", pojem.subtitle);
	
	actualTerm = index
}

// rozsekání řetězce na jednotlivé řádky
function delinearize(retez) {
var radky = retez.split(lineDelimiter)
return radky.join("\n");
}

// zobvrazení pojmu s daným názvem
function showTermNamed(jmeno) {
  jmeno = jmeno.toLowerCase()
  var termExists = false;
  for (var i = 0; i< terminy.length; i++) {
    if (terminy[i].title.toLowerCase() == jmeno) {
      showTerm(i);
      termExists = true;
      actualTerm = i
      break;
    }
  }
  if (!termExists) {  alert("Termín není v databázi.");
    
  }
}

// JavaScript StringBuffer umožňující spojování řetězců mnohem rychleji než
// operátor "+", znatelné především v IE

function StringBuffer() { 
  this.buffer = []; 
} 

StringBuffer.prototype.append = function append(string) { 
  this.buffer.push(string); 
  return this; 
}; 

StringBuffer.prototype.toString = function toString() { 
  return this.buffer.join(""); 
};

// převedení pojmu z wiki-sekvence na HTML pro zobrazení pojmu
function wikify(retez) { 

var pozice = 0;
var buf = new StringBuffer();

var radky = retez.split(lineDelimiter)

for (var i =0; i< radky.length; i++) {
  //alert("Radek " + i + ": " + radky[i])
  if (radky[i] == "") continue;
  buf.append("<p>");
  var zasobnik = new Array()
  //var odkazovy = new Regexp
  for (var j = 0; j< radky[i].length; j++) {
    
    if (radky[i].charAt(j) == "{" 
      && ("i<>".indexOf(radky[i].charAt(j+1)) > -1 ) 
      ) { //pozor, obrazek
      
      var zbytek = radky[i].substring(j+1);
      
      var obrazek = zbytek.substring(0, zbytek.indexOf("}}"))
      var alignment = (obrazek.charAt(0) == "i") ? "" : obrazek.charAt(0);
      var casti = obrazek.split("{");
      casti[1] = (casti[1].indexOf("}") > -1 ) ?  casti[1].substring(0, casti[1].length-1) : casti[1]
      buf.append("<img src=\"" + casti[1]  + "\"");
      
      if (alignment == "<") { buf.append(" class='imgLeft'") }
      if (alignment == ">") { buf.append(" class='imgRight'") }
      
      if (casti.length == 3) {
        buf.append(" class=" + casti[2]);
        }    
      buf.append(" \/>");
      
    j += obrazek.length +3;
    continue;
    }
    
    if (radky[i].charAt(j) == "{" && radky[i].charAt(j+1) == "{" ) {
      //alert("odkaz")
      var zbytek = radky[i].substring(j+2);
      
      var odkaz = zbytek.substring(0, zbytek.indexOf("}}"))
      var casti = odkaz.split("|");
      if (casti.length == 2) {
        buf.append("<a href=\"" + casti[1] + "\" target=\"_blank\">" + casti[0] + "</a>");
        }    
      if (casti.length == 1) {
        buf.append("<span class=\"innerRef\" onclick=\"showTermNamed('" + casti[0] +"')\">" + casti[0] + "</span>");
      }
      
    j += odkaz.length +3;
    continue;
    }
    
    if (radky[i].charAt(j) == "/" && radky[i].charAt(j+1) == "/" ) {
      if (zasobnik.isLast("em")) {
        zasobnik.pop();
        buf.append("</em>");
      }
      else {
        zasobnik.push("em");
        buf.append("<em>"); 
        
      }
    j += 1;
    continue;
    }
    
    if (radky[i].charAt(j) == "*" && radky[i].charAt(j+1) == "*" ) {
      if (zasobnik.isLast("strong")) {
        zasobnik.pop();
        buf.append("</strong>");
      }
      else {
        zasobnik.push("strong");
        buf.append("<strong>"); 
        
      }
    j += 1;
    continue;
    }
    
    buf.append(radky[i].charAt(j));
  }
   buf.append("</p>");
  }
 
 
return buf.toString(); 
}

function getValue(nodeId) {
  return document.getElementById(nodeId).value
}

function setHTML(nodeId, retez) {
  document.getElementById(nodeId).innerHTML = retez; 
}
  
pictures = new Array()
actualPicture = 0

// zobrazení seznamu vyhledaných pojmů
function showList(filter) {
  setHTML( "list_content", createList(filter))


} 

// vytvoření seznamu pojmů, které obsahují hledaný řetězec filter
function createList(filter) {
  filter = filter.toLowerCase();
  var buf = new StringBuffer();
  
  buf.append("<select size=\"20\" onkeyup=\"showTerm(this.value,true)\" onclick=\"showTerm(this.value,true)\">\n");
	for (var i =0; i< terminy.length; i++) {
  if (terminy[i].title.toLowerCase().indexOf(filter) == 0) {
    buf.append("<option value=\"" + i + "\">" + terminy[i].title + "</option>\n");
    }
  }

	buf.append("</select>");
  
	return buf.toString();
}

// hledání v názvech pojmů
function searchTitles() {
  var filter = getValue("searched_title");
  filter = filter.toLowerCase();
  var buf = new StringBuffer();
  
  buf.append("<select size=\"20\" onkeyup=\"showTerm(this.value,true)\" onclick=\"showTerm(this.value,true)\">\n");
	for (var i =0; i< terminy.length; i++) {
	 if (terminy[i].title.toLowerCase().indexOf(filter) > -1) {
    buf.append("<option value=\"" + i + "\">" + terminy[i].title + "</option>\n");
    }
  }

	buf.append("</select>");

	setHTML("list_content", buf.toString());
}


// uzávorkování řetězce
function quote(retez) {
return "\"" + retez  + "\"";
}

// zobrazení uzlu s id="nodeId"
function showNode(nodeId) {
  document.getElementById(nodeId).style.visibility = "visible"
}
    

// zjištění, zda retez je poslední prvek pole 
Array.prototype.isLast = function(retez) {
  if (this.length == 0) return false;
  else {
    if (this[this.length-1] == retez) return true;
    else return false;
  }
}

// nahrazenmí všech výskytů podřetězce stare řetězcem nove
String.prototype.replaceAll = function(stare, nove) {
  var nahrada = new RegExp(stare,"g")
  return this.replace(nahrada, nove)
}
